package com.nationrel.modules.fta.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;

/**
 * FTA 顶事件分析结果表：一个顶事件（子集）可包含多个最小割集
 *
 * @TableName fta_analysis_calc_result
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
@TableName(value ="fta_analysis_calc_result")
public class FtaAnalysisCalcResult {

    @TableId(type = IdType.AUTO)
    private String id;

    @Schema(description = "顶事件或中间事件的id")
    private String middleId;

    @Schema(description = "单个最小割集")
    private String minCutSet;

    @Schema(description = "单个最小割集对应的计算结果")
    private String minCutSetF;

    @Schema(description = "单个最小割集对应的计算结果")
    private String minCutSetR;

    @Schema(description = "单个最小割集对应的计算结果")
    private String minCutSetLamdba;

    @Schema(description = "单个最小割集对应的计算结果")
    private String minCutSetMtbf;
}
