// Copyright(c) 2021 ReliaQube. All rights reserved.
// 自动生成文件，再次生成时将覆盖修改内容
package com.nationrel.modules.fta.vo;

import com.nationrel.modules.fta.entity.FtaAnalysis;
import com.nationrel.modules.fta.entity.FtaAnalysisSetting;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;
import org.hibernate.validator.constraints.Length;

import java.util.Date;
import java.util.List;

@Schema(description = "分析树")
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class FtaAnalysisTreeVo {

    @Schema(description = "分析ID")
    private String id;

    @Schema(description = "projectId")
    private String projectId;

    @Schema(description = "analysisId")
    private String analysisId;

    @Schema(description = "分析名称")
    private String analysisName;

    @Schema(description = "父级Id")
    private String fatherId;

    @Schema(description = "label")
    private String label;

    @Schema(description = "showInput")
    private Boolean showInput;

    @Schema(description = "当前层级：0: 功能 1：最外层树，其它：子树")
    private Integer level;

    @Schema(description = "视图类型 1宽松 2常规 3紧凑（不支持排序）")
    private String viewType;

    @Schema(description = "children")
    private List<FtaAnalysisTreeVo> children;

    private Date createTime;

    @Schema(description = "分析配置id")
    private Integer settingId;

    @Schema(description = "是否输出顶事件与中间事件失效概率F")
    private String calculateF;

    @Schema(description = "是否输出顶事件与中间事件可靠度R")
    private String calculateR;

    @Schema(description = "是否输出顶事件与中间事件失效率λ")
    private String calculateLamda;

    @Schema(description = "是否输出顶事件与中间事件MTBF")
    private String calculateMtbf;

    @Schema(description = "是否输出最小割集失效概率F")
    private String calculateMinCutsetF;

    @Schema(description = "是否输出最小割集可靠度R")
    private String calculateMinCutsetR;

    @Schema(description = "是否输出最小割集失效率λ")
    private String calculateMinCutsetLamda;

    @Schema(description = "是否输出最小割集MTBF")
    private String calculateMinCutsetMtbf;

    @Schema(description = "是否输出底事件失效概率F")
    private String calculateCircleF;

    @Schema(description = "是否输出底事件可靠度R")
    private String calculateCircleR;

    @Schema(description = "是否输出底事件割集重要度FV")
    private String calculateCircleFv;

    @Schema(description = "是否输出底事件风险增加当量RAW")
    private String calculateCircleRaw;

    @Schema(description = "是否输出底事件风险减少当量RRW")
    private String calculateCircleRrw;

    @Schema(description = "是否输出底事件概率重要度mif")
    private String calculateCircleMif;

    @Schema(description = "是否输出底事件结构重要度sif")
    private String calculateCircleSif;

    @Schema(description = "是否输出底事件关键重要度cif")
    private String calculateCircleCif;

    @Schema(description = "全局时间校准参数")
    private String paramTime;

    public static FtaAnalysisTreeVo getVoByAnalysisAndSetting(FtaAnalysis analysis, FtaAnalysisSetting setting) {
        return FtaAnalysisTreeVo.builder()
                .id(analysis.getAnalysisId())
                .projectId(analysis.getProjectId())
                .analysisId(analysis.getAnalysisId())
                .analysisName(analysis.getAnalysisName())
                .fatherId(analysis.getFatherId())
                .label(analysis.getAnalysisName())
                .showInput(false)
                .level(analysis.getLevel())
                .viewType(analysis.getViewType())
                .createTime(analysis.getCreateTime())
                .settingId(setting.getId())
                .paramTime(setting.getParamTime())
                .calculateF(setting.getCalculateF())
                .calculateR(setting.getCalculateR())
                .calculateLamda(setting.getCalculateLamda())
                .calculateMtbf(setting.getCalculateMtbf())
                .calculateMinCutsetF(setting.getCalculateMinCutsetF())
                .calculateMinCutsetR(setting.getCalculateMinCutsetR())
                .calculateMinCutsetLamda(setting.getCalculateMinCutsetLamda())
                .calculateMinCutsetMtbf(setting.getCalculateMinCutsetMtbf())
                .calculateCircleF(setting.getCalculateCircleF())
                .calculateCircleR(setting.getCalculateCircleR())
                .calculateCircleFv(setting.getCalculateCircleFv())
                .calculateCircleRaw(setting.getCalculateCircleRaw())
                .calculateCircleRrw(setting.getCalculateCircleRrw())
                .calculateCircleMif(setting.getCalculateCircleMif())
                .calculateCircleSif(setting.getCalculateCircleSif())
                .calculateCircleCif(setting.getCalculateCircleCif())
                .build();
    }
}
